VirtualBox as a Service

(9 May 2009) deejross in the Ubuntu Forums provided a script to start/stop Sun's VirtualBox as a service. It's one short-coming was that it doesn't tolerate multi-word names for VM's.

VirtualBox

One of the nice features of VirtualBox is the ability to start headless VMs (i.e., runs without having to open a window to "see" the guest OS). I use it to run a Linux VM to host my internal wiki and web services. The advantage is that when I rebuild a system (and I do this more often than friends, family, & other users like), I don't have to restore the wiki. I only have to re-install Virtualbox, copy the script below, and start the VM.

VirtualBox allows for the use of multi-word names for VMs. One missing piece for VirtualBox is a script to start/stop headless VMs. Various people, such as Ross Peoples and Brendan Kidwell (links below), have written these scripts. I like Ross's script but it didn't like my naming scheme, so I've adjusted his script (shown below).

The fix

The fix is quite basic. It involves putting quotes around "VM_NAME" in Ross's script. This needs to be done on lines 36, 73, and 96. The author has already added them on line 38. (Hint: In VI, you can jump to line 36 by typing ":36" (without the quotes) in command mode.)

As an example, line 36 looks like

 DESC="VirtualBox - ${VM_NAME}"
You should add the quotes so that it looks like

 DESC="VirtualBox - '${VM_NAME}'"
My adaptation to deejross's script allows me to run a VM called "Fedora 10" under Ubuntu. I haven't changed it much (yet) but just in case I (or you) need it at a future date, here 'tis:

 #! /bin/sh
 ### BEGIN INIT INFO
 # Provides: VirtualBox - XP-Radio
 # Required-Start: $local_fs $remote_fs
 # Required-Stop: $local_fs $remote_fs
 # Default-Start: 2 3 4 5
 # Default-Stop: S 0 1 6
 # Short-Description: Handles the XP-Radio virtual machine
 # Description: This file should be used to construct scripts to be
 # placed in /etc/init.d.
 ### END INIT INFO

 # Author: Ross Peoples <ubuntu.ross.peoples@gmail.com>

 # Do NOT "set -e"

 # PATH should only include /usr/* if it runs after the mountnfs.sh script
 PATH=/usr/sbin:/usr/bin:/sbin:/bin

 #
 # CHANGE THESE AS NEEDED
 #
 # Name given to the virtual machine
 VM_NAME="Fedora 10"

 # Name of this file, excluding /etc/init.d/
 THIS_FILE=vbox-fed

 # Username to run as
 RUNAS_USERNAME=joat

 #
 # END CHANGE THESE AS NEEDED
 #

 DESC="VirtualBox - '${VM_NAME}'"
 DAEMON=/usr/bin/VBoxVRDP
 DAEMON_ARGS="-startvm \"${VM_NAME}\""
 PIDFILE=/var/run/$THIS_FILE.pid
 SCRIPTNAME=/etc/init.d/$THIS_FILE

 # Exit if the package is not installed
 [ -x "$DAEMON" ] || exit 0

 # Read configuration variable file if it is present
 [ -r /etc/default/$THIS_FILE ] && . /etc/default/$THIS_FILE

 # Load the VERBOSE setting and other rcS variables
 [ -f /etc/default/rcS ] && . /etc/default/rcS

 # Define LSB log_* functions.
 # Depend on lsb-base (>= 3.0-6) to ensure that this file is present.
 . /lib/lsb/init-functions

 #
 # Function that starts the daemon/service
 #
 do_start()
 {
 # Return
 # 0 if daemon has been started
 # 1 if daemon was already running
 # 2 if daemon could not be started
 #start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON --test > /dev/null \
 #|| return 1
 #start-stop-daemon --start --quiet --pidfile $PIDFILE --exec $DAEMON -- \
 #$DAEMON_ARGS \
 #|| return 2
 # Add code here, if necessary, that waits for the process to be ready
 # to handle requests from services started subsequently which depend
 # on this one. As a last resort, sleep for some time.

 su $RUNAS_USERNAME -c "VBoxManage startvm '${VM_NAME}' -type vrdp"
 }

 #
 # Function that stops the daemon/service
 #
 do_stop()
 {
 # Return
 # 0 if daemon has been stopped
 # 1 if daemon was already stopped
 # 2 if daemon could not be stopped
 # other if a failure occurred
 start-stop-daemon --stop --quiet --retry=TERM/30/KILL/5 --pidfile $PIDFILE --name $THIS_FILE
 RETVAL="$?"
 [ "$RETVAL" = 2 ] && return 2
 # Wait for children to finish too if this is a daemon that forks
 # and if the daemon is only ever run from this initscript.
 # If the above conditions are not satisfied then add some other code
 # that waits for the process to drop all resources that could be
 # needed by services started subsequently. A last resort is to
 # sleep for some time.

 su $RUNAS_USERNAME -c "VBoxManage controlvm '${VM_NAME}' acpipowerbutton && sleep 10"

 start-stop-daemon --stop --quiet --oknodo --retry=0/30/KILL/5 --exec $DAEMON
 [ "$?" = 2 ] && return 2
 # Many daemons don't delete their pidfiles when they exit.
 rm -f $PIDFILE
 return "$RETVAL"
 }

 #
 # Function that sends a SIGHUP to the daemon/service
 #
 do_reload() {
 #
 # If the daemon can reload its configuration without
 # restarting (for example, when it is sent a SIGHUP),
 # then implement that here.
 #
 # start-stop-daemon --stop --signal 1 --quiet --pidfile $PIDFILE --name $NAME
 echo "Reload not supported"
 return 0
 }

 case "$1" in
 start)
 [ "$VERBOSE" != no ] && log_daemon_msg "Starting $DESC" "$THIS_FILE"
 do_start
 case "$?" in
 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
 esac
 ;;
 stop)
 [ "$VERBOSE" != no ] && log_daemon_msg "Stopping $DESC" "$THIS_FILE"
 do_stop
 case "$?" in
 0|1) [ "$VERBOSE" != no ] && log_end_msg 0 ;;
 2) [ "$VERBOSE" != no ] && log_end_msg 1 ;;
 esac
 ;;
 #reload|force-reload)
 #
 # If do_reload() is not implemented then leave this commented out
 # and leave 'force-reload' as an alias for 'restart'.
 #
 #log_daemon_msg "Reloading $DESC" "$NAME"
 #do_reload
 #log_end_msg $?
 #;;
 *)
 #echo "Usage: $SCRIPTNAME {start|stop|restart|reload|force-reload}" >&2
 echo "Usage: $SCRIPTNAME {start|stop}" >&2
 exit 3
 ;;
 esac

Sources/Extra Reading